/*
* Copyright (C) 2007-2008, CompHEP Collaboration
* Author: Alexander Sherstnev 
* ------------------------------------------------------
* $Id$
*
* $Log$
*/
#include <unistd.h>
#include<stdio.h>
#include<stdlib.h>
#include<string.h>

#include "evnt_tools.h"
#include "mix_format1.h"
#include "mix_format2.h"
#include "mix_format_lhef.h"

int main (int argc, char** argv)
{
  int i;
  int nf = argc - 1;
  int frmt;
  int lenth = 0;
  char * names;

  if (argc < 2) {
    fprintf(stderr, "mix: Enter names of files with events as parameters. \n");
    return 1;
  }

  for (i = 0; i < nf; ++i) {
    int tlenth;
    FILE* inFile = fopen(argv[i + 1], "r");
    if (!inFile) {
      fprintf(stderr,"mix: error! File not found: %s\n", argv[i + 1]);
      return -2;
    } else {
      if (0 == i) frmt = CheckFormat (inFile);
      if (frmt != CheckFormat (inFile)) {
        fprintf(stderr, "mix: error! Different formats in the event files!\n");
        return -3;
      }
      tlenth = strlen (argv[i + 1]);
      if (lenth < tlenth) lenth = tlenth;
    }
    fclose (inFile);
  }

  names = malloc (nf * lenth * sizeof (char));
  for (i = 0; i < nf; ++i) {
    strcpy (names + i * lenth, argv[i + 1]);
  }

  switch (frmt) {
    case 1:
      fprintf (stdout, "mix: format cpyth2 detected in all event files\n");
      mix_format1 (nf, names, lenth);
      break;
    case 2:
      fprintf (stdout, "mix: format cpyth2 detected in all event files\n");
      mix_format2 (nf, names, lenth);
      break;
    case 4:
      fprintf (stdout, "mix: format lhe detected in all event files\n");
      mix_format_lhef (nf, names, lenth);
      break;
    default:
      fprintf(stderr, "Error! Unknown format in event files!\n");
      return 4;
    }
  free (names);
  return 0;
}
